<?php
namespace EMS\PortalFuncionario\Geral\Services;

use Zeedhi\Framework\Controller\Crud;
use Doctrine\ORM\EntityManager;

use EMS\PortalFuncionario\Geral\Repository\EstruturaRepository;

class EstruturaService extends Crud {

    public const ESTRUTURA_GERENCIAL    = 'NRESTRUTGEREN';
    public const ESTRUTURA_LEGAL        = 'NRESTRUTLEGAL';

    public const DEFAULT_ESTRUTURA_PONTO_ACESSO     = self::ESTRUTURA_GERENCIAL;
    public const SECONDARY_ESTRUTURA_PONTO_ACESSO   = self::ESTRUTURA_LEGAL;

    public function __construct(EntityManager $entityManager, EstruturaRepository $estruturaRepository) {
        $this->entityManager                = $entityManager;
        $this->estruturaRepository          = $estruturaRepository;
    }

    public function getPontoAcesso(string $nrorg, string $nrvinculom) : array {
        try {
            return $this->estruturaRepository->getPontoAcesso($nrorg, $nrvinculom);
        } catch (\Exception $e) {
            throw $e;
        }
    }
  
}