/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_FASECONT                                                 */
/* Tabela : FASECONT                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 17/08/2004 - Welbert G. Moitinha                                           */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_FASECONT'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_FASECONT
GO

CREATE TRIGGER DTULTATU_FASECONT
ON FASECONT
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'FASECONT', null, 'CDFASECONT=' + CDFASECONT + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE FASECONT
      SET DTULTATUFACO = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(FASECONT.CDFASECONT,0) = ISNULL(INSERTED.CDFASECONT,0)) AND
            (ISNULL(FASECONT.NMFASECONT,0) = ISNULL(INSERTED.NMFASECONT,0)) ;
   END;
END;
GO

